Index: src/includes/classes/Smarty/Smarty.class.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/Smarty.class.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/Smarty.class.php	(revision )
@@ -1596,121 +1481,36 @@
     {
         restore_error_handler();
     }
-
+    
-
-	/**
-	 * This method checks if a USERMOD of the given template exists and replaces it with the USERMOD
-	 * 
-	 * @param $p_template
-	 *
-	 * @return string
-	 */
-	protected function _getGambioUsermodFilePath($p_template)
-	{
-		// try absolute path
-		$usermodFilePath = get_usermod($p_template);
-		if($usermodFilePath != $p_template) return $usermodFilePath;
-
-		if((defined('DIR_FS_CATALOG') && strpos($p_template, DIR_FS_CATALOG) !== 0) || defined('DIR_FS_CATALOG') == false)
-		{
-			// try relative path
-			$templateDir = $this->template_dir . '/';
-			if(strpos($p_template, $templateDir) === 0)
-			{
-				$templateDir = '';
-			}
-
-			$usermodFilePath = get_usermod($templateDir . $p_template);
-			if($usermodFilePath != $templateDir . $p_template) return $usermodFilePath;
-		}
-
-		// no usermod-resource found. return original
-		return $p_template;
-	}
+    /**
+     * This method checks if a USERMOD of the given template exists and replaces it with the USERMOD
+     *
+     * @param $p_template
+     *
+     * @return string
+     */
+    protected function _getGambioUsermodFilePath($p_template)
+    {
+        // try absolute path
+        $usermodFilePath = get_usermod($p_template);
+        if($usermodFilePath != $p_template) return $usermodFilePath;
+        
+        if((defined('DIR_FS_CATALOG') && strpos($p_template, DIR_FS_CATALOG) !== 0) || defined('DIR_FS_CATALOG') == false)
+        {
+            // try relative path
+            $templateDir = $this->template_dir . '/';
+            if(strpos($p_template, $templateDir) === 0)
+            {
+                $templateDir = '';
+            }
+            
+            $usermodFilePath = get_usermod($templateDir . $p_template);
+            if($usermodFilePath != $templateDir . $p_template) return $usermodFilePath;
+        }
+        
+        // no usermod-resource found. return original
+        return $p_template;
+    }
 }
 
 require(DIR_FS_CATALOG. 'includes/classes/Smarty/SmartyBC.class.php');
-// Check if we're running on windows
-Smarty::$_IS_WINDOWS = strtoupper(substr(PHP_OS, 0, 3)) === 'WIN';
-
-// let PCRE (preg_*) treat strings as ISO-8859-1 if we're not dealing with UTF-8
-if (Smarty::$_CHARSET !== 'UTF-8') {
-    Smarty::$_UTF8_MODIFIER = '';
-}
-
-/**
- * Smarty exception class
- *
- * @package Smarty
- */
-class SmartyException extends Exception
-{
-    public static $escape = false;
-
-    public function __toString()
-    {
-        return ' --> Smarty: ' . (self::$escape ? htmlentities($this->message) : $this->message) . ' <-- ';
-    }
-}
-
-/**
- * Smarty compiler exception class
- *
- * @package Smarty
- */
-class SmartyCompilerException extends SmartyException
-{
-    public function __toString()
-    {
-        return ' --> Smarty Compiler: ' . $this->message . ' <-- ';
-    }
-
-    /**
-     * The line number of the template error
-     *
-     * @type int|null
-     */
-    public $line = null;
-    /**
-     * The template source snippet relating to the error
-     *
-     * @type string|null
-     */
-    public $source = null;
-    /**
-     * The raw text of the error message
-     *
-     * @type string|null
-     */
-    public $desc = null;
-    /**
-     * The resource identifier or template name
-     *
-     * @type string|null
-     */
-    public $template = null;
-}
-
-/**
- * Autoloader
- */
-function smartyAutoload($class)
-{
-    $_class = strtolower($class);
-    static $_classes = array(
-        'smarty_config_source'               => true,
-        'smarty_config_compiled'             => true,
-        'smarty_security'                    => true,
-        'smarty_cacheresource'               => true,
-        'smarty_cacheresource_custom'        => true,
-        'smarty_cacheresource_keyvaluestore' => true,
-        'smarty_resource'                    => true,
-        'smarty_resource_custom'             => true,
-        'smarty_resource_uncompiled'         => true,
-        'smarty_resource_recompiled'         => true,
-    );
-
-    if (!strncmp($_class, 'smarty_internal_', 16) || isset($_classes[$_class])) {
-        include SMARTY_SYSPLUGINS_DIR . $_class . '.php';
-    }
-}
Index: src/includes/classes/Smarty/sysplugins/smarty_template_cached.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_template_cached.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_template_cached.php	(revision )
@@ -0,0 +1,246 @@
+<?php
+/**
+ * Created by PhpStorm.
+ * User: Uwe Tews
+ * Date: 04.12.2014
+ * Time: 06:08
+ */
+
+/**
+ * Smarty Resource Data Object
+ * Cache Data Container for Template Files
+ *
+ * @package    Smarty
+ * @subpackage TemplateResources
+ * @author     Rodney Rehm
+ */
+class Smarty_Template_Cached extends Smarty_Template_Resource_Base
+{
+    /**
+     * Cache Is Valid
+     *
+     * @var boolean
+     */
+    public $valid = null;
+
+    /**
+     * CacheResource Handler
+     *
+     * @var Smarty_CacheResource
+     */
+    public $handler = null;
+
+    /**
+     * Template Cache Id (Smarty_Internal_Template::$cache_id)
+     *
+     * @var string
+     */
+    public $cache_id = null;
+
+    /**
+     * saved cache lifetime in seconds
+     *
+     * @var integer
+     */
+    public $cache_lifetime = 0;
+
+    /**
+     * Id for cache locking
+     *
+     * @var string
+     */
+    public $lock_id = null;
+
+    /**
+     * flag that cache is locked by this instance
+     *
+     * @var bool
+     */
+    public $is_locked = false;
+
+    /**
+     * Source Object
+     *
+     * @var Smarty_Template_Source
+     */
+    public $source = null;
+
+    /**
+     * Nocache hash codes of processed compiled templates
+     *
+     * @var array
+     */
+    public $hashes = array();
+
+    /**
+     * create Cached Object container
+     *
+     * @param Smarty_Internal_Template $_template template object
+     */
+    public function __construct(Smarty_Internal_Template $_template)
+    {
+        $this->compile_id = $_template->compile_id;
+        $this->cache_id = $_template->cache_id;
+        $this->source = $_template->source;
+        if (!class_exists('Smarty_CacheResource', false)) {
+            require SMARTY_SYSPLUGINS_DIR . 'smarty_cacheresource.php';
+        }
+        $this->handler = Smarty_CacheResource::load($_template->smarty);
+    }
+
+    /**
+     * @param Smarty_Internal_Template $_template
+     *
+     * @return Smarty_Template_Cached
+     */
+    static function load(Smarty_Internal_Template $_template)
+    {
+        $_template->cached = new Smarty_Template_Cached($_template);
+        $_template->cached->handler->populate($_template->cached, $_template);
+        // caching enabled ?
+        if (!($_template->caching == Smarty::CACHING_LIFETIME_CURRENT ||
+                $_template->caching == Smarty::CACHING_LIFETIME_SAVED) || $_template->source->handler->recompiled
+        ) {
+            $_template->cached->valid = false;
+        }
+        return $_template->cached;
+    }
+
+    /**
+     * Render cache template
+     *
+     * @param \Smarty_Internal_Template $_template
+     * @param  bool                     $no_output_filter
+     *
+     * @throws \Exception
+     */
+    public function render(Smarty_Internal_Template $_template, $no_output_filter = true)
+    {
+        if ($this->isCached($_template)) {
+            if ($_template->smarty->debugging) {
+                $_template->smarty->_debug->start_cache($_template);
+            }
+            if (!$this->processed) {
+                $this->process($_template);
+            }
+            $this->getRenderedTemplateCode($_template);
+            if ($_template->smarty->debugging) {
+                $_template->smarty->_debug->end_cache($_template);
+            }
+            return;
+        } else {
+            $_template->smarty->ext->_updateCache->updateCache($this, $_template, $no_output_filter);
+        }
+    }
+
+    /**
+     * Check if cache is valid, lock cache if required
+     *
+     * @param \Smarty_Internal_Template $_template
+     *
+     * @return bool flag true if cache is valid
+     */
+    public function isCached(Smarty_Internal_Template $_template)
+    {
+        if ($this->valid !== null) {
+            return $this->valid;
+        }
+        while (true) {
+            while (true) {
+                if ($this->exists === false || $_template->smarty->force_compile || $_template->smarty->force_cache) {
+                    $this->valid = false;
+                } else {
+                    $this->valid = true;
+                }
+                if ($this->valid && $_template->caching == Smarty::CACHING_LIFETIME_CURRENT &&
+                    $_template->cache_lifetime >= 0 && time() > ($this->timestamp + $_template->cache_lifetime)
+                ) {
+                    // lifetime expired
+                    $this->valid = false;
+                }
+                if ($this->valid && $_template->smarty->compile_check == 1 &&
+                    $_template->source->getTimeStamp() > $this->timestamp
+                ) {
+                    $this->valid = false;
+                }
+                if ($this->valid || !$_template->smarty->cache_locking) {
+                    break;
+                }
+                if (!$this->handler->locked($_template->smarty, $this)) {
+                    $this->handler->acquireLock($_template->smarty, $this);
+                    break 2;
+                }
+                $this->handler->populate($this, $_template);
+            }
+            if ($this->valid) {
+                if (!$_template->smarty->cache_locking || $this->handler->locked($_template->smarty, $this) === null) {
+                    // load cache file for the following checks
+                    if ($_template->smarty->debugging) {
+                        $_template->smarty->_debug->start_cache($_template);
+                    }
+                    if ($this->handler->process($_template, $this) === false) {
+                        $this->valid = false;
+                    } else {
+                        $this->processed = true;
+                    }
+                    if ($_template->smarty->debugging) {
+                        $_template->smarty->_debug->end_cache($_template);
+                    }
+                } else {
+                    $this->is_locked = true;
+                    continue;
+                }
+            } else {
+                return $this->valid;
+            }
+            if ($this->valid && $_template->caching === Smarty::CACHING_LIFETIME_SAVED &&
+                $_template->cached->cache_lifetime >= 0 &&
+                (time() > ($_template->cached->timestamp + $_template->cached->cache_lifetime))
+            ) {
+                $this->valid = false;
+            }
+            if ($_template->smarty->cache_locking) {
+                if (!$this->valid) {
+                    $this->handler->acquireLock($_template->smarty, $this);
+                } elseif ($this->is_locked) {
+                    $this->handler->releaseLock($_template->smarty, $this);
+                }
+            }
+            return $this->valid;
+        }
+        return $this->valid;
+    }
+
+    /**
+     * Process cached template
+     *
+     * @param Smarty_Internal_Template $_template template object
+     * @param bool                     $update    flag if called because cache update
+     */
+    public function process(Smarty_Internal_Template $_template, $update = false)
+    {
+        if ($this->handler->process($_template, $this, $update) === false) {
+            $this->valid = false;
+        }
+        if ($this->valid) {
+            $this->processed = true;
+        } else {
+            $this->processed = false;
+        }
+    }
+
+    /**
+     * Read cache content from handler
+     *
+     * @param Smarty_Internal_Template $_template template object
+     *
+     * @return string content
+     */
+    public function read(Smarty_Internal_Template $_template)
+    {
+        if (!$_template->source->handler->recompiled) {
+            return $this->handler->readCachedContent($_template);
+        }
+        return false;
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_compilealltemplates.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_compilealltemplates.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_compilealltemplates.php	(revision )
@@ -0,0 +1,111 @@
+<?php
+
+/**
+ * Smarty Method CompileAllTemplates
+ *
+ * Smarty::compileAllTemplates() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_CompileAllTemplates
+{
+    /**
+     * Valid for Smarty object
+     *
+     * @var int
+     */
+    public $objMap = 1;
+
+    /**
+     * Compile all template files
+     *
+     * @api  Smarty::compileAllTemplates()
+     *
+     * @param \Smarty $smarty
+     * @param  string $extension     file extension
+     * @param  bool   $force_compile force all to recompile
+     * @param  int    $time_limit
+     * @param  int    $max_errors
+     *
+     * @return integer number of template files recompiled
+     */
+    public function compileAllTemplates(Smarty $smarty, $extension = '.tpl', $force_compile = false, $time_limit = 0, $max_errors = null)
+    {
+        return $this->compileAll($smarty, $extension, $force_compile, $time_limit, $max_errors);
+    }
+
+    /**
+     * Compile all template or config files
+     *
+     * @param \Smarty $smarty
+     * @param  string $extension     template file name extension
+     * @param  bool   $force_compile force all to recompile
+     * @param  int    $time_limit    set maximum execution time
+     * @param  int    $max_errors    set maximum allowed errors
+     * @param bool    $isConfig      flag true if called for config files
+     *
+     * @return int number of template files compiled
+     */
+    protected function compileAll(Smarty $smarty, $extension, $force_compile, $time_limit, $max_errors, $isConfig = false)
+    {
+        // switch off time limit
+        if (function_exists('set_time_limit')) {
+            @set_time_limit($time_limit);
+        }
+        $_count = 0;
+        $_error_count = 0;
+        $sourceDir = $isConfig ? $smarty->getConfigDir() : $smarty->getTemplateDir();
+        // loop over array of source directories
+        foreach ($sourceDir as $_dir) {
+            $_dir_1 = new RecursiveDirectoryIterator($_dir);
+            $_dir_2 = new RecursiveIteratorIterator($_dir_1);
+            foreach ($_dir_2 as $_fileinfo) {
+                $_file = $_fileinfo->getFilename();
+                if (substr(basename($_fileinfo->getPathname()), 0, 1) == '.' || strpos($_file, '.svn') !== false) {
+                    continue;
+                }
+                if (!substr_compare($_file, $extension, - strlen($extension)) == 0) {
+                    continue;
+                }
+                if ($_fileinfo->getPath() == !substr($_dir, 0, - 1)) {
+                    $_file = substr($_fileinfo->getPath(), strlen($_dir)) . DS . $_file;
+                }
+                echo "\n<br>", $_dir, '---', $_file;
+                flush();
+                $_start_time = microtime(true);
+                $_smarty = clone $smarty;
+                $_smarty->force_compile = $force_compile;
+                try {
+                    /* @var Smarty_Internal_Template $_tpl */
+                    $_tpl = new $smarty->template_class($_file, $_smarty);
+                    $_tpl->caching = Smarty::CACHING_OFF;
+                    $_tpl->source = $isConfig ? Smarty_Template_Config::load($_tpl) : Smarty_Template_Source::load($_tpl);
+                    if ($_tpl->mustCompile()) {
+                        $_tpl->compileTemplateSource();
+                        $_count ++;
+                        echo ' compiled in  ', microtime(true) - $_start_time, ' seconds';
+                        flush();
+                    } else {
+                        echo ' is up to date';
+                        flush();
+                    }
+                }
+                catch (Exception $e) {
+                    echo "\n<br>        ------>Error: ", $e->getMessage(), "<br><br>\n";
+                    $_error_count ++;
+                }
+                // free memory
+                unset($_tpl);
+                $_smarty->_cache['template_objects'] = array();
+                if ($max_errors !== null && $_error_count == $max_errors) {
+                    echo "\n<br><br>too many errors\n";
+                    exit();
+                }
+            }
+        }
+        echo "\n<br>";
+        return $_count;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/plugins/shared.mb_wordwrap.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/shared.mb_wordwrap.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/shared.mb_wordwrap.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_config_load.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_config_load.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_config_load.php	(revision )
@@ -23,6 +23,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $required_attributes = array('file');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -30,30 +31,39 @@
      * @see Smarty_Internal_CompileBase
      */
     public $shorttag_order = array('file', 'section');
+
     /**
      * Attribute definition: Overwrites base class.
      *
      * @var array
      * @see Smarty_Internal_CompileBase
      */
-    public $optional_attributes = array('section', 'scope');
+    public $optional_attributes = array('section', 'scope', 'bubble_up');
 
     /**
+     * Valid scope names
+     * 
+     * @var array
+     */
+    public $valid_scopes = array('local'  => true, 'parent' => true, 'root' => true, 'global' => true,
+                                 'smarty' => true, 'tpl_root' => true);
+
+    /**
      * Compiles code for the {config_load} tag
      *
-     * @param  array  $args     array with attributes from parser
+     * @param  array                                $args     array with attributes from parser
-     * @param  object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
-        static $_is_legal_scope = array('local' => true, 'parent' => true, 'root' => true, 'global' => true);
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
 
         if ($_attr['nocache'] === true) {
-            $compiler->trigger_template_error('nocache option not allowed', $compiler->lex->taglineno);
+            $compiler->trigger_template_error('nocache option not allowed', null, true);
         }
 
         // save possible attributes
@@ -63,19 +73,31 @@
         } else {
             $section = 'null';
         }
-        $scope = 'local';
-        // scope setup
+        $_scope = Smarty::SCOPE_LOCAL;
         if (isset($_attr['scope'])) {
             $_attr['scope'] = trim($_attr['scope'], "'\"");
-            if (isset($_is_legal_scope[$_attr['scope']])) {
-                $scope = $_attr['scope'];
-            } else {
-                $compiler->trigger_template_error('illegal value for "scope" attribute', $compiler->lex->taglineno);
+            if (!isset($this->valid_scopes[$_attr['scope']])) {
+                $compiler->trigger_template_error("illegal value '{$_attr['scope']}' for \"scope\" attribute", null, true);
             }
+            if ($_attr['scope'] != 'local') {
+                if ($_attr['scope'] == 'parent') {
+                    $_scope = Smarty::SCOPE_PARENT;
+                } elseif ($_attr['scope'] == 'root') {
+                    $_scope = Smarty::SCOPE_ROOT;
+                } elseif ($_attr['scope'] == 'global') {
+                    $_scope = Smarty::SCOPE_GLOBAL;
+                } elseif ($_attr['scope'] == 'smarty') {
+                    $_scope = Smarty::SCOPE_SMARTY;
+                } elseif ($_attr['scope'] == 'tpl_root') {
+                    $_scope = Smarty::SCOPE_TPL_ROOT;
-        }
+                }
+                $_scope += (isset($_attr['bubble_up']) && $_attr['bubble_up'] == 'false') ? 0 : Smarty::SCOPE_BUBBLE_UP;
+            }
+        }
+
         // create config object
-        $_output = "<?php  \$_config = new Smarty_Internal_Config($conf_file, \$_smarty_tpl->smarty, \$_smarty_tpl);";
-        $_output .= "\$_config->loadConfigVars($section, '$scope'); ?>";
+        $_output =
+            "<?php\n\$_smarty_tpl->smarty->ext->configLoad->_loadConfigFile(\$_smarty_tpl, {$conf_file}, {$section}, {$_scope});\n?>\n";
 
         return $_output;
     }
Index: src/includes/classes/Smarty/sysplugins/smarty_template_resource_base.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_template_resource_base.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_template_resource_base.php	(revision )
@@ -0,0 +1,155 @@
+<?php
+
+/**
+ * Smarty Template Resource Base Object
+ *
+ * @package    Smarty
+ * @subpackage TemplateResources
+ * @author     Rodney Rehm
+ */
+abstract class Smarty_Template_Resource_Base
+{
+    /**
+     * Compiled Filepath
+     *
+     * @var string
+     */
+    public $filepath = null;
+
+    /**
+     * Compiled Timestamp
+     *
+     * @var integer
+     */
+    public $timestamp = null;
+
+    /**
+     * Compiled Existence
+     *
+     * @var boolean
+     */
+    public $exists = false;
+
+    /**
+     * Template Compile Id (Smarty_Internal_Template::$compile_id)
+     *
+     * @var string
+     */
+    public $compile_id = null;
+
+    /**
+     * Compiled Content Loaded
+     *
+     * @var boolean
+     */
+    public $processed = false;
+
+    /**
+     * unique function name for compiled template code
+     *
+     * @var string
+     */
+    public $unifunc = '';
+
+    /**
+     * flag if template does contain nocache code sections
+     *
+     * @var bool
+     */
+    public $has_nocache_code = false;
+
+    /**
+     * resource file dependency
+     *
+     * @var array
+     */
+    public $file_dependency = array();
+
+    /**
+     * Content buffer
+     *
+     * @var string
+     */
+    public $content = null;
+
+    /**
+     * required plugins
+     *
+     * @var array
+     */
+    public $required_plugins = array();
+
+    /**
+     * Included subtemplates
+     *
+     * @var array
+     */
+    public $includes = array();
+
+    /**
+     * Process resource
+     *
+     * @param Smarty_Internal_Template $_template template object
+     */
+    abstract public function process(Smarty_Internal_Template $_template);
+
+     /**
+     * get rendered template content by calling compiled or cached template code
+     *
+     * @param string $unifunc function with template code
+     *
+     * @return string
+     * @throws \Exception
+     */
+    public function getRenderedTemplateCode(Smarty_Internal_Template $_template, $unifunc = null)
+    {
+        $unifunc = isset($unifunc) ? $unifunc : $this->unifunc;
+        $level = ob_get_level();
+        try {
+            if (empty($unifunc) || !is_callable($unifunc)) {
+                throw new SmartyException("Invalid compiled template for '{$_template->template_resource}'");
+            }
+            if (isset($_template->smarty->security_policy)) {
+                $_template->smarty->security_policy->startTemplate($_template);
+            }
+            //
+            // render compiled or saved template code
+            //
+            if (!isset($_template->_cache['capture_stack'])) {
+                $_template->_cache['capture_stack'] = array();
+            }
+            $_saved_capture_level = count($_template->_cache['capture_stack']);
+            $unifunc($_template);
+            // any unclosed {capture} tags ?
+            if ($_saved_capture_level != count($_template->_cache['capture_stack'])) {
+                $_template->capture_error();
+            }
+            if (isset($_template->smarty->security_policy)) {
+                $_template->smarty->security_policy->exitTemplate();
+            }
+            return null;
+        }
+        catch (Exception $e) {
+            while (ob_get_level() > $level) {
+                ob_end_clean();
+            }
+             if (isset($_template->smarty->security_policy)) {
+                $_template->smarty->security_policy->exitTemplate();
+            }
+            throw $e;
+        }
+    }
+
+    /**
+     * Get compiled time stamp
+     *
+     * @return int
+     */
+    public function getTimeStamp()
+    {
+        if ($this->exists && !isset($this->timestamp)) {
+            $this->timestamp = @filemtime($this->filepath);
+        }
+        return $this->timestamp;
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_tplfunction.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_tplfunction.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_tplfunction.php	(revision )
@@ -0,0 +1,97 @@
+<?php
+
+/**
+ * Tplfunc Runtime Methods callTemplateFunction
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ *
+ **/
+class Smarty_Internal_Runtime_TplFunction
+{
+    /**
+     * Call template function
+     *
+     * @param \Smarty_Internal_Template $tpl     template object
+     * @param string                    $name    template function name
+     * @param array                     $params  parameter array
+     * @param bool                      $nocache true if called nocache
+     *
+     * @throws \SmartyException
+     */
+    public function callTemplateFunction(Smarty_Internal_Template $tpl, $name, $params, $nocache)
+    {
+        if (isset($tpl->tpl_function[$name])) {
+            if (!$tpl->caching || ($tpl->caching && $nocache)) {
+                $function = $tpl->tpl_function[$name]['call_name'];
+            } else {
+                if (isset($tpl->tpl_function[$name]['call_name_caching'])) {
+                    $function = $tpl->tpl_function[$name]['call_name_caching'];
+                } else {
+                    $function = $tpl->tpl_function[$name]['call_name'];
+                }
+            }
+            if (function_exists($function)) {
+                $function ($tpl, $params);
+                return;
+            }
+            // try to load template function dynamically
+            if ($this->addTplFuncToCache($tpl, $name, $function)) {
+                $function ($tpl, $params);
+                return;
+            }
+        }
+        throw new SmartyException("Unable to find template function '{$name}'");
+    }
+
+    /**
+     *
+     * Add template function to cache file for nocache calls
+     *
+     * @param Smarty_Internal_Template $tpl
+     * @param string                   $_name     template function name
+     * @param string                   $_function PHP function name
+     *
+     * @return bool
+     */
+    public function addTplFuncToCache(Smarty_Internal_Template $tpl, $_name, $_function)
+    {
+        $funcParam = $tpl->tpl_function[$_name];
+        if (is_file($funcParam['compiled_filepath'])) {
+            // read compiled file
+            $code = file_get_contents($funcParam['compiled_filepath']);
+            // grab template function
+            if (preg_match("/\/\* {$_function} \*\/([\S\s]*?)\/\*\/ {$_function} \*\//", $code, $match)) {
+                // grab source info from file dependency
+                preg_match("/\s*'{$funcParam['uid']}'([\S\s]*?)\),/", $code, $match1);
+                unset($code);
+                // make PHP function known
+                eval($match[0]);
+                if (function_exists($_function)) {
+                    // search cache file template
+                    $tplPtr = $tpl;
+                    while (!isset($tplPtr->cached) && isset($tplPtr->parent)) {
+                        $tplPtr = $tplPtr->parent;
+                    }
+                    // add template function code to cache file
+                    if (isset($tplPtr->cached)) {
+                        $cache = $tplPtr->cached;
+                        $content = $cache->read($tplPtr);
+                        if ($content) {
+                            // check if we must update file dependency
+                            if (!preg_match("/'{$funcParam['uid']}'(.*?)'nocache_hash'/", $content, $match2)) {
+                                $content = preg_replace("/('file_dependency'(.*?)\()/", "\\1{$match1[0]}", $content);
+                            }
+                            $tplPtr->smarty->ext->_updateCache->write($cache, $tplPtr, preg_replace('/\s*\?>\s*$/', "\n", $content) . "\n" .
+                                                 preg_replace(array('/^\s*<\?php\s+/', '/\s*\?>\s*$/'), "\n",
+                                                              $match[0]));
+                        }
+                    }
+                    return true;
+                }
+            }
+        }
+        return false;
+    }
+}
